grid = [ ...
    '#########'; ...
    '#b.A.@.a#'; ...
    '#########'];








grid = [ ...
    '#################################################################################'; ...
    '#.....#.............................#...#k......#.........#....h........#.....#.#'; ...
    '###.#.#####.#.#####################.###.#.#.#####.###.#####.#####.#####.#.###.#.#'; ...
    '#...#.....#.#.#...#.............#.#...#.#.#.....#...#.#.....#.M...#...#.#...#...#'; ...
    '#.#######.###.#.###.###.#######.#.###.#.#.#####.###.#.#.#####.#####.#.#.###.#####'; ...
    '#...#...#.....#.......#.#...#.#...#.#.#.#...#i#.....#.#...#.#.......#.#.....#...#'; ...
    '###G#.#.#####.#######.#.#.#.#.###.#.#.#.###.#.#######.###.#.#########.#####.#.#.#'; ...
    '#...#.#.#.....#...#...#...#.#.....#.#...#.#.#.....#.....#.#...B...#.#...#...#.#.#'; ...
    '#.#####.#.#####.#.###.#####.#####.#.###.#.#.#####.#.#####.#.#####.#.###.#.###.#.#'; ...
    '#.....#.......#.#...#..c#.#.#...#...#...#.#....r..#.......#...#..l#...#.#.#...#.#'; ...
    '#.###.#########.###.###.#.#.#.#.#####.###.#######.#########.#.###.###.#.###.###.#'; ...
    '#...#.............#.#.#.#.#.#.#.....#...#.......#...#.....#.#...#.....#.....O.#.#'; ...
    '#.#####.###########.#.#.#.#.#.#####.###.#L###.#####.#.###.#####X#####.#########.#'; ...
    '#.#...#.#.....#.....#...#.#.....#.....#.#...#.....#...#.#.....#...#.......#j....#'; ...
    '#.#.#.#.###.###.#####.###.#######.###.#.###.###.#######.#####.###.#.#######.#####'; ...
    '#.#.#.#.....#...#...#.#.......#...#...#.#...#...#...........#...#.#..p#.....#...#'; ...
    '###.#.#####.#.#####.#.#.#######.###.###.#.###.#.#.#########.###.#.###.#.#####.#.#'; ...
    '#...#.....#.#.....#.#.#.......#.#.....#.#.#.#.#.#...#.....#...#.#...#.#.......#.#'; ...
    '#.#######.#######.#.#.#######.#.#######.#P#.#.#####.#.###.#.###.#.#.#######.###.#'; ...
    '#.#.............#.#.......#...#.......#.#...#.......#.#.#.#.....#.#.#.....#.#.#.#'; ...
    '#D#############.#.#######.#.#########.#.#############.#.#.#####.###.#.###.#.#.#.#'; ...
    '#...#.......#.....#...#.#.#.........#...#.............#.#.....#.....#.#...#...#.#'; ...
    '###.#.#####.#######.###.#.###.#.###.#####.#############.#############.#.#######.#'; ...
    '#.#...#...#b........#...#...#.#...#...#.#.#...............#...........#.......#.#'; ...
    '#.#####.#############.#####.#####.###.#.#.#############.#.#####.#############.#.#'; ...
    '#.#.......#.....#.....#.....#...#.#...#.#.....#.........#.....#.#.....#u....#...#'; ...
    '#.#.#####.#.###.#.###.#.#####.#.#.#.###.#####.#.#############.#.#.###.#####.###.#'; ...
    '#.#.#.....#...#.#...#.#.#.....#...#...#.#...#.#...#.........#.#.....#.....#.#...#'; ...
    '#.#.#.#######.#.#.###.#.###.#.#######.#.#.#.#.#.#.#.#######.#.#####.#####.#S#.###'; ...
    '#.#.#.#.....#.#.#.#...#...#.#...#....f..#.#...#.#.#.....#...#.....#.....#.#.....#'; ...
    '#.#.#.#.###.#.#.#.#.#####.#####.#########.#######.#####.#########.#####.#.#####.#'; ...
    '#.#.#.....#.#.#.#.#.....#.....#.........#.#.......#.....#.........#.#...#.....#.#'; ...
    '#.#.#######.#.#.#Q#####.#####.#.#######.#.#.#.#####.#####.#########.#.#####.#F#.#'; ...
    '#.#.#...#...#.#.....#.....#...#.....#...#.#.#.#.....#.....#...#.......#.T.#q#.#.#'; ...
    '#.#.###.#.#.#.#######.###.#.#######.#.#.#.###.#.###.#.#######.#.#######.#.###.#.#'; ...
    '#.#...#.#.#.#.Z.#.....#...#.#.....#.#.#.#.....#...#.#.......#.......#...#...#.#.#'; ...
    '#.###.#.#.#####.#.#########.#.###.###.#.###########.#######.#######.#.#####.#.#.#'; ...
    '#..o#.#.#.......#.........#...#...#...#.#.#...............#.......#.#...#.#.#.#.#'; ...
    '#.#.#.#.#################.#####.###.###.#.#.###.#################.#####.#.#.#.#.#'; ...
    '#.#.J...................#...........#.........#.........V......n........#.....#.#'; ...
    '#######################################.@.#######################################'; ...
    '#...#.........#.........#.#...............#...........#.......#...#.....#.......#'; ...
    '#.###.#####.#.#.#######.#.#.#.#########.#.#.#######.#.#####.#.#.#.###.#.###.#.###'; ...
    '#...#.#.....#.#.#.N.#.....#v#.#.........#.#...#.#...#...#...#...#.....#...#.#e..#'; ...
    '#.#.#.#U#####.#.#.#.#######.#.#####.#####.###.#.#.#####.#.###############.###.#.#'; ...
    '#.#...#...#.#.#...#.#.......#.....#.....#.#.....#.#.....#.#.#.....#.....#z..#.#.#'; ...
    '#.#######.#.#.#.###.#.#########.#.#######.#.#####.#.#####.#.#.#.###.#.#####.###.#'; ...
    '#.......#.#...#t..#...#...#...#.#.......#.#.#.#...#.......#...#...#.#.....#.....#'; ...
    '#######.#.###.###.#######.#.#.#.#######.#.#.#.#.###########.#####.#.#####.#####.#'; ...
    '#.......#...#.#...#.......#.#.#.....#...#.#...#.........#...#...#.#.#...#.....#.#'; ...
    '###########.#.#.###.#######.#.#######.#.#.###.#####.###.###.#.#.#.#.#.#.###.###.#'; ...
    '#...........#.#...#.......#.#...#...#.#.#.....#...#.#.#...#.#.#.#.....#.#.#.#...#'; ...
    '#.###########.###.#######.#.###.#.#.#.#.#.#####.#.#.#.###.###.#.#######.#.#.#.###'; ...
    '#.#...#...#.#..s#.#.....#.#.#...#.#...#.#.#...#.#.#.....#.....#.......#.#.#...#w#'; ...
    '#.#.#.#.#.#E###.#.#.###.#.#.###.#.#####.###.#.#.#.###########.#######.#.#.#####.#'; ...
    '#.#.#...#.#.....#.#.#.#...#...#...#...#.#...#...#...........#.#...#...#.....#...#'; ...
    '#.#.#####.#.#####.#.#.###.###.#######.#.#.#################.###.#.#.#######.#.#.#'; ...
    '#...#.....#.#.......#.......#...#.....#.#.#...#.........#.......#...#.....#.#.#.#'; ...
    '#.###.#####.#.#################.#.#.###.#.#.#.#.###.#.###.###########.###.#.#.###'; ...
    '#.#.#.....#.#.#...............#.#.#.....#...#.#...#.#.#...#...........#...#.#...#'; ...
    '#.#.#####.#.###.#.###########.#.#.###########.###.#.###.###.###.#######.###.###Y#'; ...
    '#...#...#.#...#.#.#...#.....#...#...#...#.....#...#.....#...#.#...#.....#...#...#'; ...
    '###.###.#.###.#.#.#.#######.#######.###.#.###########.###.###.#####.#####.###.###'; ...
    '#..a#...#.#.#.#.#.#.#.....#.....#...#...#...#.......#.#.#...#......d#.....#.....#'; ...
    '#.###.#.#.#.#.#.#.#.###.#.#.###.#.###.###.#.#.#####.#.#.###.#########.#######.#.#'; ...
    '#.#...#.#.#.#...#.#..x..#.#...#.#...#...#.#.......#.#.....#.......#.#.#.....#.#.#'; ...
    '#.#.#####.#.#####.#######.###.#.###.###.#.#########.###.#########.#.#.#.###.###.#'; ...
    '#...#...#.#...#.......#...#...#...#.#...#.#...#.....#...#.......#.#...#.#.#.....#'; ...
    '#####.#.#.#.#.#.#######.###.#######.#.###.###.#.#########.###.#.#.###.#.#.#####.#'; ...
    '#.....#...#.#.....#.....#.#.......#.#...#...#.#.........#...#.#.#...#.#.#.......#'; ...
    '#.#########.#######.#####.#.#####.#.###.###.#.#########.###.#.#####.#.#.#####.###'; ...
    '#.....#.......#.I...#.C...#.#...#...#...#.#...#.......#.....#.#...#.#.#.....#...#'; ...
    '#.###.#########.#######.#.#.#.#.#####.#.#.###.#.#.###.#######.#.#.#.#.#####.###.#'; ...
    '#...#...#...W.#...#...#.#.....#.#.....#.#.....#.#...#...#.....#.#.#.#.....#...#.#'; ...
    '#.#####.#.###.###.#.#R#########.###.###.#.#########.###.#.#####.#.#.#####.#.#.###'; ...
    '#.#.....#.#.#...#...#.....#...#.#...#.#.#...#...#...#...#.H.#...#...#.#...#.#...#'; ...
    '#.#.#####.#.#.###########.#.###.#.###.#.###.#.#.#.###.#####.#.#######.#.#######.#'; ...
    '#y#.....#.#.#...K.........#...#...#...#.#.#...#.#.#.#.#...#g#.....#...#...#...#.#'; ...
    '#.#####.#.#.###############.#.#####.###.#.#####.#.#.#.#.#.#.#####.#.#.###.#.#.#.#'; ...
    '#.....#...#.................#...........#........m#.....#.#.......#.#.....A.#...#'; ...
    '#################################################################################'];









































% 
% 
% 
% 
% 
% grid = [ ...
%     '#################'; ...
%     '#i.G..c...e..H.p#'; ...
%     '########.########'; ...
%     '#j.A..b...f..D.o#'; ...
%     '########@########'; ...
%     '#k.E..a...g..B.n#'; ...
%     '########.########'; ...
%     '#l.F..d...h..C.m#'; ...
%     '#################'];

% grid = [ ...
%     '########################'; ...
%     '#...............b.C.D.f#'; ...
%     '#.######################'; ...
%     '#.....@.a.B.c.d.A.e.F.g#'; ...
%     '########################'];
% 
% grid = [ ...
%     '########################'; ...
%     '#f.D.E.e.C.b.A.@.a.B.c.#'; ...
%     '######################.#'; ...
%     '#d.....................#'; ...
%     '########################'];
% 
% 
% 
% 
% grid = [ ...
%     '########################'; ...
%     '#@..............ac.GI.b#'; ...
%     '###d#e#f################'; ...
%     '###A#B#C################'; ...
%     '###g#h#i################'; ...
%     '########################'];




az = char(97:122);
AZ = char(65:90);
keysInGrid = az(ismember(az, grid));
doorsInGrid = AZ(ismember(AZ, grid));

% numStepsMin = +Inf;
% for retry = 1 : 100
%     pos = getPosition(grid, '@');
%     keysCollected = char([]);
%     numSteps = 0;
%     while ~all(ismember(keysInGrid, keysCollected))
%         shortestPathToKeys = arrayfun( ...
%             @(x) shortestPathInGrid(convertGridForPathComputation(grid, keysCollected), ...
%             pos, getPosition(grid, x)), az);
%         shortestPathToKeys(shortestPathToKeys == 0) = +Inf;
%         shortestPathToKeys(ismember(az, keysCollected)) = +Inf;
%
%         %Select randomly the next key to get
%         idx = find(~isinf(shortestPathToKeys));
%         idx = idx(randi(numel(idx)));
%         numStepsIncr = shortestPathToKeys(idx);
%
%         numSteps = numSteps + numStepsIncr;
%         keysCollected(end+1) = az(idx);
%         pos = getPosition(grid, az(idx));
%     end
%     numStepsMin = min(numSteps, numStepsMin)
% end
%
% numStepsMin

tic
sp = d18_computeShortestPath(grid, keysInGrid);
[res, cache] = numStepsToCollectKeys(grid, '@', keysInGrid, '', sp)
toc


function [numSteps, cache] = numStepsToCollectKeys(grid, pos, keysToCollect, keysCollected, sp, cache)

numSteps = 0;
if isempty(keysToCollect); return; end
if nargin == 5; cache.key = char(zeros(0,55)); cache.dist = []; end

% gridTmp = convertGridForPathComputation(grid, keysCollected);
% 
% shortestPathToKeys = +Inf * ones(1, numel(keysToCollect));
% itemsOnPath = repmat({''}, 1, numel(keysToCollect));
% for idx = 1 : numel(keysToCollect)
%     [shortestPathToKeys(idx), itemsOnPath{idx}] = shortestPathInGrid(gridTmp, pos, getPosition(grid, keysToCollect(idx)));
%     if any(ismember(keysToCollect, itemsOnPath(idx)))
%         shortestPathToKeys(idx) = +Inf;
%     end
% end
% shortestPathToKeys(shortestPathToKeys == 0) = +Inf;
% shortestPathToKeys(ismember(keysToCollect, keysCollected)) = +Inf;
% shortestPathToKeys(shortestPathToKeys > 2*averagePathLength) = +Inf;


spTmp = sp(sp.pathStart == pos & ismember(sp.pathEnd, keysToCollect) & sp.distance ~= 0 & ~isinf(sp.distance) & sp.isUsable, :);


numStepsIncr = +Inf * ones(1, size(spTmp,1));
for idx = 1 : numel(numStepsIncr)
        keyCurrent = spTmp.pathEnd(idx);
        keysToCollectTmp = keysToCollect;
        keysToCollectTmp = keysToCollectTmp(keysToCollectTmp ~= keyCurrent);
        keysCollectedTmp = [keysCollected, keyCurrent];
        spCopy = d18_computeShortestPath(grid, keysToCollectTmp, keysCollectedTmp, sp);
%         spCopy = spCopy(spCopy.pathStart ~= pos, :);
        
        k = [keyCurrent, '_', pad(sort(keysCollectedTmp), 26), '_', pad(sort(keysToCollectTmp), 26)];
        index = find(all(cache.key == k, 2));
        if ~isempty(index)
            numStepsIncr(idx) = spTmp.distance(idx) + cache.dist(index);
        else
            [v, cache] = numStepsToCollectKeys(grid, keyCurrent, keysToCollectTmp, keysCollectedTmp, spCopy, cache);
            numStepsIncr(idx) = spTmp.distance(idx) + v;
            cache.key(end+1,:) = k;
            cache.dist(end+1) = v;
        end
end
numSteps = numSteps + min(numStepsIncr);

if isequal(pos, getPosition(grid, '@'))
    disp([keysCollected, ' num steps = ', num2str(numSteps)]);
end



end

function numStepsToCollectKeys2(grid, pos, keysToCollect, keysCollected, sp, numStepsIn)

if nargin == 5; numStepsIn = 0; end

if isempty(keysToCollect)
    disp([keysCollected, ' num steps = ', num2str(numStepsIn)]);
    return;
end

spTmp = sp(sp.pathStart == pos & ismember(sp.pathEnd, keysToCollect) & sp.distance ~= 0 & ~isinf(sp.distance) & sp.isUsable, :);
if isempty(spTmp)
    numSteps = +Inf;
    return;
end

spTmp = sortrows(spTmp, 'distance');


numStepsIncr = +Inf * ones(1, size(spTmp,1));
for idx = 1 : numel(numStepsIncr)
        keyCurrent = spTmp.pathEnd(idx);
        keysToCollectTmp = keysToCollect;
        keysToCollectTmp = keysToCollectTmp(keysToCollectTmp ~= keyCurrent);
        keysCollectedTmp = [keysCollected, keyCurrent];
        spCopy = d18_computeShortestPath(grid, keysToCollectTmp, keysCollectedTmp, sp);
        numStepsToCollectKeys2(grid, keyCurrent, keysToCollectTmp, keysCollectedTmp, spCopy, numStepsIn + spTmp.distance(idx));
end
end




function pos = getPosition(grid, character)
[row, col] = ind2sub(size(grid), find(grid == character));
pos = [row, col];
end

function gridOut = convertGridForPathComputation(gridIn, keysCollected)
gridOut = repmat('#', size(gridIn,1), size(gridIn,2));
gridOut(ismember(gridIn, ['.@', char(97:122), keysCollected, upper(keysCollected)])) = '.';
end


